import es, playerlib, gamethread, zombiehellconfig, random, usermsg
from zombiehellconfig import *

temp_zombies = stock_zombies
wins = 0

info = es.AddonInfo() 
info['name']        = "Zombie Hell 2.0" 
info['version']     = "1.0" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/zombiehell2" 
info['description'] = "A python version of ZombieHell requested by Undead for better speed + performance" 

es.ServerVar('zh2_version', info['version'], 'ZombieHell 2.0 made by Bonbon AKA Bonbon367').makepublic()

def load():
	add_downloads()
	fog_start()
	for type in ammo:
		es.server.queuecmd('%s %s'%(type, ammo[type]))
	knife_bot()
	add_bots()
	es.server.queuecmd('mp_limitteams 0;mp_autoteambalance 0')

def unload():
	if es.getuserid():
		es.server.queuecmd('es_xfire %s env_fog_controller kill'%es.getuserid())
	for loop in ['update_hud']:
		gamethread.cancelDelayed(loop)
	kick_bots()

#### Events ###

def player_spawn(ev):
	userid = ev['userid']
	Player(userid).set_attributes()
	es.trick('dispatcheffect %s ManHackSparks 1'%userid)
	Player(ev['userid']).check_team()

def player_death(ev):
	userid = ev['userid']
	if dissolve_on_death:
		Player(userid).dissolve()
	Player(userid).check_respawn()
	Player(userid).play_sound()

def es_map_start(ev):
	global wins
	wins = 0
	fog_start()
	add_downloads()
	knife_bot()

def item_pickup(ev):
	Player(ev['userid']).check_restrict(ev['item'])
	if ev['item'] == 'c4': es.server.queuecmd('es_xfire %s weapon_c4 kill'%ev['userid'])

def player_hurt(ev):
	Player(ev['attacker']).check_restrict(ev['weapon'])
	Player(ev['userid']).play_sound()

def round_start(ev):
	global temp_zombies
	temp_zombies = len(playerlib.getUseridList('#human')) * stock_zombies + int(wins * stock_multiplier)

def round_freeze_end(ev):
	if 0 < wins < rounds_to_win:
		es.msg('#multi', '#lightgreenWARNING: #defaultQuarantine in level #lightgreen%s#default has been breeched! KILL ON SIGHT!'%wins)
	elif wins == rounds_to_win:
		for userid in es.getUseridList():
			usermsg.shake(userid, 50, 4.5)
		es.msg('#multi', '#lightgreenWARNING: #default Quarantine in level #lightgreen%s#default has been breeched! ZOMBIES HAVE EVOLVED!'%wins)
	else:
		global wins
		wins = 0

def round_end(ev):
	global wins
	if es.getUseridList() > 2:
		wins = max(0, wins + (1 if not len(playerlib.getUseridList('#bot,#alive')) else -1))
		if wins > rounds_to_win:
			es.msg('#multi', '#defaultCongratulations on defeating all the zombies, The game will end in #lightgreen5#default seconds')
			gamethread.delayed(5, es.server.queuecmd, 'es_entcreate %s game_end;es_fire %s game_end endgame'%(es.getuserid(), es.getuserid()))
	else:
		es.msg('Not enough players to start')

def player_team(ev):
	Player(ev['userid']).check_team()

### Classes ###

class Player:
	def __init__(self, userid):
		self.userid = userid
		self.steamid = es.getplayersteamid(userid)

	def dissolve(self):
		if not playerlib.getPlayer(self.userid).get('isdead'):
			playerlib.getPlayer(self.userid).set('health', 0)
			es.server.queuecmd('es_xfire %s !self ignite'%self.userid)
		es.server.queuecmd('es_give %s env_entity_dissolver'%self.userid)
		es.server.queuecmd('es_xfire %s env_entity_dissolver AddOutput "target cs_ragdoll"'%self.userid)
		es.server.queuecmd('es_xfire %s env_entity_dissolver AddOutput "magnitude 1"'%self.userid)
		es.server.queuecmd('es_xfire %s env_entity_dissolver AddOutput "dissolvetype %s"'%(self.userid, random.randint(0, 3)))
		es.server.queuecmd('es_xfire %s env_entity_dissolver Dissolve'%self.userid)
		gamethread.delayed(1, es.server.queuecmd, 'es_xfire %s env_entity_dissolver kill'%self.userid)

	def check_restrict(self, weapon):
		if self.steamid == 'BOT' and not 'knife' in weapon:
			es.server.queuecmd('es_xgive %s player_weaponstrip'%self.userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip StripWeaponsAndSuit'%self.userid)
			es.server.queuecmd('es_xgive %s weapon_knife'%self.userid)
		elif weapon.replace('weapon_', '') in restricted_weapons:
			for index in es.createentitylist('weapon_%s'%weapon.replace('weapon_', '')):
				if int(es.getplayerhandle(self.userid)) == int(es.getindexprop(index, "CBaseEntity.m_hOwnerEntity")):
					es.server.queuecmd('es_xremove %s'%index)
					es.tell(self.userid, '#multi', '#greenSorry, the #lightgreen%s #greenis restricted'%(weapon.replace('weapon_', '')))

	def check_respawn(self):
		if self.steamid == 'BOT':
			if temp_zombies > 0:
				global temp_zombies
				temp_zombies -= 1
				es.server.queuecmd('est_spawn %s'%self.userid)

	def set_attributes(self):
		if self.steamid == 'BOT':
			if random.randint(1, 100) > boss_chance or wins < rounds_to_win:
				# es.msg('rounds %s wins %s random value %s add %s stockpile %s'%(rounds_to_win, wins, random_value(zombie_health_min, zombie_health_max), wins * zombie_health_level_bonus_multiplier, temp_zombies))
				playerlib.getPlayer(self.userid).set('model', random.choice(zombie_models))
				playerlib.getPlayer(self.userid).set('health', random_value(zombie_health_min, zombie_health_max) + (wins * zombie_health_level_bonus_multiplier))
				playerlib.getPlayer(self.userid).set('speed', random_value(zombie_speed_min, zombie_speed_max) + (wins * zombie_speed_level_bonus_multiplier))
				playerlib.getPlayer(self.userid).set('armor', random_value(zombie_armor_min, zombie_armor_max) + (wins * zombie_armor_level_bonus_multiplier))
			else:
				es.msg(wins, rounds_to_win, wins < rounds_to_win)
				playerlib.getPlayer(self.userid).set('model', boss_model)
				playerlib.getPlayer(self.userid).set('health', random_value(boss_health_min, boss_health_max))
				playerlib.getPlayer(self.userid).set('speed', random_value(boss_speed_min, boss_speed_max))
				playerlib.getPlayer(self.userid).set('armor', random_value(boss_armor_min, boss_armor_max))
			playerlib.getPlayer(self.userid).set('cash', 0)
		else:
			if start_cash:
				playerlib.getPlayer(self.userid).set('cash', start_cash)

	def hud(self):
		humans = 0
		zombies = 0
		for userid in playerlib.getUseridList('#human,#alive'):
			humans += 1
		for userid in playerlib.getUseridList('#bot,#alive'):
			zombies += 1
		usermsg.hudhint(self.userid, '!!! Zombie Hell !!!\nHumans: %s\nZombies: %s\nDifficulty: %s\nReserve: %s'%(humans, zombies, messages[wins], temp_zombies))

	def play_sound(self):
		if self.steamid == 'BOT':
			if random.randint(0, 1):
				sounds = []
				for a in range(1, 10):
					if a < 5:
						sounds.append('npc/zombie/moan_loop' + str(a))
					if a < 4:
						sounds.append('npc/zombie/zombie_die' + str(a))
						sounds.append('npc/zombie/zombie_alert' + str(a))
					if sounds < 7:
						sounds.append('npc/zombie/zombie_pain' + str(a))
					sounds.append('npc/zombie/zombie_voice_idle' + str(a))
				sound = random.choice(sounds)
				es.emitsound('player', self.userid, sound + '.wav', 0.8, 0.4)
				gamethread.delayed(3, es.stopsound, (self.userid, sound + '.wav'))

	def check_team(self):
		if es.exists('userid', self.userid):
			if self.steamid == 'BOT':
				if not playerlib.getPlayer(self.userid).get('teamid') == 2:
					es.server.queuecmd('est_team %s 2'%self.userid)
			else:
				if playerlib.getPlayer(self.userid).get('teamid') == 2:
					es.server.queuecmd('est_team %s 3'%self.userid)
					es.tell(self.userid, '#multi', '#lightgreen[Zombie Hell]: #defaultHumans can only be on the #lightgreenTerrorists')

### Functions ###

def add_downloads():
	for a in downloadables:
		es.stringtable('downloadables', a)

def fog_start():
	if zombie_fog:
		userid = es.getuserid()
		r, g, b = zombie_fog_rgb
		r2, g2, b2 = zombie_fog_rgb2
		if userid:
			es.server.queuecmd('es_xfire %s env_fog_controller turnoff'%userid)
			es.server.queuecmd('es_xfire %s env_fog_controller kill'%userid)
			es.server.queuecmd('es_xgive %s env_fog_controller'%userid)
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogdir %s %s %s\"'%(userid, 0, 0, 0))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogstart %s\"'%(userid, 50))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogend %s\"'%(userid, 1000))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogblend 1"'%userid)
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor %s %s %s\"'%(userid, r, g, b))
			es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor2 %s %s %s\"'%(userid, r2, g2, b2))
			es.server.queuecmd('es_xfire %s env_fog_controller turnon'%userid)

def knife_bot():
	es.server.queuecmd('bot_knives_only 1')
	es.server.queuecmd('bot_join_after_player 0')

def add_bots():
	bots = zombie_bots
	while bots > 0:
		es.server.queuecmd('bot_add')
		bots -= 1
	change_teams()

def kick_bots():
	es.server.queuecmd('bot_kick')

def change_teams():
	for userid in es.getUseridList():
		Player(userid).check_team()

### Returns ###

def random_value(low, high):
	return random.randint(int(low * 1000), int(high * 1000)) / 1000.0

### Loops ###

def update_hud():
	for userid in es.getUseridList():
		Player(userid).hud()
	gamethread.delayedname(hud_update_time, 'update_hud', update_hud)

update_hud()



